/*-----------------------------------------------------------------
	Copyright 1994 Steve Israelson
-----------------------------------------------------------------*/
#pragma once

#include <LSingleDoc.h>
#include <LListener.h>
#include <LList.h>
#include "marathonTypes.h"

#define editorFileType			'scen'


class	myDocument : public LSingleDoc , public LListener{
public:
	marathonMap			theMapFile;
	LWindow				**levelWindows;
	
						myDocument(LCommander *inSuper, FSSpec *inFileSpec);
						~myDocument();
					
	virtual Boolean		IsModified();
	virtual Boolean		AllowSubRemoval(LCommander *inSub);
	
	virtual void		DoAESave(FSSpec &inFileSpec, OSType inFileType);
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	void				DoSaveTo(LFile *oldFile, LFile *newFile);
	void 				readNameChunks(short fileRefNum);
	void				editLevel(short theLevelNum);
	void				readLevel(short theLevelNum);
	void				setNameList(void);

	virtual void	ListenToMessage(MessageT inMessage, void *ioParam);
			
protected:
	void				NameNewDoc();
	void				OpenFile(FSSpec &inFileSpec);
};